config/routes.rb
# encoding: UTF-8

# Routes
Rails.application.routes.draw do
  # Bookings
  resources :bookings do
    collection do
      post :select
    end
    member do
      get :select_booking
      get :copy
    end
  end

  resources :accounts do
    member do
      get :csv_bookings
      get :edit_bookings
      post :update_bookings
    end
    resources :bookings
    resources :attachments
  end

  resources :banks do
    resources :phone_numbers
    member do
      get :new_phone_number
    end
    collection do
      get :new_phone_number
    end
  end

  resources :bank_accounts do
    member do
      get :csv_bookings
    end
    resources :bookings
    resources :attachments
  end

  resources :booking_templates do
    member do
      get :new_booking
    end
  end
end

app/controllers/accounts_controller.rb
class AccountsController < HasAccountsController
  # Scopes
  has_scope :by_date, :using => [:from, :to], :default => proc { |c| c.session[:has_scope] }
  has_scope :by_text

  has_scope :page, :only => :index

  def index
    @accounts = collection.includes(:account_type).includes(:credit_bookings, :credit_bookings).page(params[:page]).per_page(100)
  end

  def show
    @account = Account.find(params[:id])
    @bookings = apply_scopes(Booking).includes(:debit_account => :account_type, :credit_account => :account_type).by_account(@account)
    @bookings = @bookings.page(params[:page] || 1)
    @bookings = @bookings.per_page(params[:per_page].to_i) if params[:per_page].present?

    if params[:only_credit_bookings]
      @bookings = @bookings.where(:credit_account_id => @account.id)
    end
    if params[:only_debit_bookings]
      @bookings = @bookings.where(:debit_account_id => @account.id)
    end
    @bookings = @bookings
    @carry_booking = @bookings.all.first
    @saldo = @account.saldo(@carry_booking, false)

    if @account.profit_account? && params[:by_date] && params[:by_date][:to]
      @saldo -= @account.saldo(Date.parse(params[:by_date][:from]), false)
    end

    show!
  end

  def csv_bookings
    @account = Account.find(params[:id])
    @bookings = apply_scopes(Booking).by_account(@account)
    send_csv @bookings, :only => [:value_date, :title, :comments, :amount, 'credit_account.code', 'debit_account.code'], :filename => "%s-%s.csv" % [@account.code, @account.title]
  end

  def edit_bookings
    @account = Account.find(params[:id])
    @bookings = apply_scopes(Booking).by_account(@account)
  end

  def update_bookings
    bookings = params[:bookings]

    bookings.each do |id, attributes|
      attributes.merge!({:credit_account_id => Account.find_by_code(attributes[:credit_account_code]).id})
      attributes.merge!({:debit_account_id => Account.find_by_code(attributes[:debit_account_code]).id})
      Booking.find(id).update_attributes(attributes)
    end

    account = Account.find(params[:id])
    redirect_to account
  end
end

app/helpers/account_helper.rb
module AccountHelper
  def accounts_as_collection(accounts = nil)
    accounts ||= Account.all
    accounts.collect{|account| ["%s - %s" % [account.code, account.title], account.id]}
  end
end

app/views/accounts/_account.html.haml
%tr[account]
  %td= account.code
  %td
    = link_to account.title, url_for(account), {'data-href-container' => 'tr'}
    .pull-right= account.tags.map{|tag| boot_label(tag.name)}.join(' ').html_safe
  %td.action-links
    = list_link_for(:edit, account)
    = list_link_for(:delete, account)

app/views/accounts/_booking_item.html.haml
%tr[@booking]
  %td= @booking.value_date
  %td= @booking.code
  %td
    = link_to @booking.title, @booking, {'data-href-container' => 'tr'}
    - if @booking.comments.present?
      %hr{:style => "height: 1px; margin: 0"}/
      %i= @booking.comments
  %td
    - begin
      = link_to @booking.reference.to_s(:reference), @booking.reference unless @booking.reference.nil?
    - rescue
      = @booking.reference.try(:to_s)
  %td.currency= (@booking.debit_account == @account) ? currency_fmt(@booking.amount) : content_tag('i', link_to(@booking.debit_account.code, account_path(@booking.debit_account), :title => @booking.debit_account.title))
  %td.currency= (@booking.credit_account == @account) ? currency_fmt(@booking.amount) : content_tag('i', link_to(@booking.credit_account.code, account_path(@booking.credit_account), :title => @booking.credit_account.title))
  %td.currency= currency_fmt(@saldo)
  %td.action-links
    = list_link_for(:edit, [@account, @booking])
    = list_link_for(:delete, [@account, @booking], :remote => true)
    = list_link_for(:copy, @booking)

app/views/accounts/_booking_list_footer.html.haml
= render 'accounts/booking_list_turnover'
= render 'accounts/booking_list_saldo'

app/views/accounts/_booking_list_saldo.html.haml
%tr#booking_list_saldo{:style => "border-top: double 2px black"}
  %td{:colspan => "3"}
    Kontostand (per #{@bookings.last.value_date})
  %td
  %td
  %td
  %td{:style => "text-align: right"}= currency_fmt(@account.saldo(@bookings.last))
  %td.action-links

app/views/accounts/_booking_list_turnover.html.haml
- credit_turnover, debit_turnover = @account.turnover(@bookings)
%tr#booking_list_turnover{:style => "border-top: double 2px black"}
  %td{:colspan => "4"}
    Umsatz (#{h @bookings.first.value_date} bis #{h @bookings.last.value_date})
  %td{:style => "text-align: right"}= currency_fmt(debit_turnover)
  %td{:style => "text-align: right"}= currency_fmt(credit_turnover)
  %td
  %td.action-links

app/views/accounts/_carry_booking.html.haml
%tr{:id => "carry_booking"}
  %td= @carry_booking.value_date
  %td
  %td
    = t('bookyt.carry_booking')
  %td
  %td
  %td
  %td{:style => "text-align: right"}= currency_fmt(@saldo)
  %td.action-links

app/views/accounts/_edit_bookings.html.haml
- url_params = {:controller => 'accounts', :action => 'show', :id => params[:account_id] || params[:id]}
= simple_form_for :bookings, :url => update_bookings_account_path do |f|
  %table.table.table-striped
    %thead
      %tr
        %th= t_attr :value_date, Booking
        %th= t_attr :title, Booking
        %th= t_attr :amount, Booking
        %th= t_attr :debit_account, Booking
        %th= t_attr :credit_account, Booking
    %tbody
      = render :partial => 'edit_booking', :collection => @bookings, :locals => {:f => f}

  = f.button :submit

= paginate @bookings, :params => url_params.merge(:query => params[:query]) do

app/views/accounts/_list.html.haml
%table.table.table-striped.accounts.collection
  %thead
    %tr
      %th= t_attr(:code, Account)
      %th= t_attr(:title, Account)
      %th.action-links
  %tbody
    = render @accounts

= render 'bookings/sidebar'

app/views/accounts/_list_footer.html.haml
%tr
  %th{:colspan => "4", :style => "text-align: right"}= will_paginate @accounts, :params => {:query => params[:query]}

app/views/accounts/_show.html.haml
.tabbable
  %ul.nav.nav-tabs
    %li.active= link_to t_title(:journal, Account), '#tab-bookings', {:data => {:toggle => 'tab'}}
    %li= link_to t_title(:info, Account), '#tab-info', {:data => {:toggle => 'tab'}}
    - if resource.respond_to? :attachments
      %li= link_to t_title(:list, Attachment), '#tab-attachments', {:data => {:toggle => 'tab'}}

.tab-content
  #tab-bookings.tab-pane.active= render 'show_bookings'
  #tab-info.tab-pane= render "form"
  - if resource.respond_to? :attachments
    #tab-attachments.tab-pane= render 'show_attachments'

app/views/accounts/_show_bookings.html.haml
- url_params = {:controller => 'accounts', :action => 'show', :id => params[:account_id] || params[:id]}

= paginate @bookings

%table.table.table-striped.bookings.collection
  %thead
    = render 'accounts/booking_list_header'
  %tbody
    = render 'accounts/carry_booking' unless @saldo == 0

    - for @booking in @bookings
      - amount = @booking.amount
      - amount = -(amount) if @account.liability_account?
      - @saldo += @booking.accounted_amount(@account)
      = render 'accounts/booking_item'
  %tfoot
    = render 'accounts/booking_list_footer' unless @bookings.empty?

= paginate @bookings

app/views/accounts/edit_bookings.html.haml
= contextual_links

= boot_page_title

= render 'edit_bookings'

app/views/accounts/edit_bookings.js.erb
$('#edit_bookings').replaceWith('<%=escape_javascript render "edit_bookings" %>');
$('#edit-bookings').addClass('active');

app/views/accounts/show.html.haml
.contextual
  = icon_link_to :only_debit_bookings, url_for(:only_debit_bookings => true) unless params[:only_debit_bookings]
  = icon_link_to :only_credit_bookings, url_for(:only_credit_bookings => true) unless params[:only_credit_bookings]
  = icon_link_to :all_bookings, @account if params[:only_credit_bookings] || params[:only_debit_bookings]
  = icon_link_to :print, params.merge({:format => :pdf, :per_page => 5000, :page => 1})
  = contextual_links_for

= boot_page_title
= render 'show'

= render 'bookings/sidebar'